//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double Lots    = 0.1;
extern double Media_2 =  20;
extern double Media_3 =  65;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double Ma_2, Ma_3;
   double Ma_2_Prev, Ma_3_Prev;
   int cnt, ticket, total;
   
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   
   
// to simplify the coding and speed up access
// data are put into internal variables
   
   Ma_2      = iMA(NULL,0,Media_2,0,MODE_EMA,PRICE_CLOSE,0);
   Ma_3      = iMA(NULL,0,Media_3,0,MODE_EMA,PRICE_CLOSE,0);
   Ma_2_Prev = iMA(NULL,0,Media_2,0,MODE_EMA,PRICE_CLOSE,1);
   Ma_3_Prev = iMA(NULL,0,Media_3,0,MODE_EMA,PRICE_CLOSE,1);

   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if(Close[1] < Ma_3_Prev && Close[0] > Ma_3 && Ma_2 > Ma_3)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,0,NULL,NULL,"3_20",16384,0,Green);
            if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
       if(Close[1] > Ma_3_Prev && Close[0] < Ma_3 && Ma_2 < Ma_3)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,0,NULL,NULL,"3_20",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
  
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if((Close[1] > Ma_3_Prev && Close[0] < Ma_3) ||  (Close[1] > Ma_2_Prev && Close[0] < Ma_2))
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,0,Violet); // close position
                 return(0); // exit
                }
            }
         else // go to short position
           {
            // should it be closed?
             if((Close[1] < Ma_3_Prev && Close[0] > Ma_3) ||  (Close[1] < Ma_2_Prev && Close[0] > Ma_2))
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,0,Violet); // close position
               return(0); // exit
              }
            
           }
        }
     }
   return(0);
  }
// the end.